#ifndef __CDFPRED_H
#define __CDFPRED_H

/* korelacja i dekorelacja */

#include "cdftypes.h"

/* zakres i domyslna wart. predyktora */
#define MINpred -1
#define MAXpred 9
#define DEFpred 8

/* predyktory >= 0 opisane w .c */
/* predyktor -1 oznacza kopiowanie wiersza bez modyfikacji */

/* inicjalizacja struktur dekorelacji - wypelnienie tablicy statycznej dla wersji do 8bpp */
/* nie wymaga zwolnienia */
void decorelateinit8bpp(int bpp);

/* dekorelacja, row 0 - aware */
/* arg.: poprzedni i altualny wiersz, numer wiersza, liczba pikseli wiersza (>0)*/
/* numer predyktora i bufor na wiersz po dekorelacji */
void decorelaterow(const PIXEL *prevrow, const PIXEL *currow, int row, int rowlen, int bpp,
				   int pred, PIXEL *decorelatedrow);
void decorelaterow8bpp(const BYTE *prevrow, const BYTE *currow, int row, int rowlen, int bpp,
				       int pred, BYTE *decorelatedrow);

/* korelacja, odwaraca operacje decorelaterow */
void corelaterow(const PIXEL *prevrow, PIXEL *currow, int row, int rowlen, int bpp,
				   int pred, const PIXEL *decorelatedrow);



#endif
